//  ***************************************************************
//  EntBomb - Creation date: 12/15/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef EntBomb_h__
#define EntBomb_h__

#include "Main.h"
#include "Entity.h"

class EntBomb:public Entity
{
public:
	EntBomb();
	virtual ~EntBomb();
	void StartTicking();

	virtual void Render();
	virtual void Update(float step);
	bool Init(int tileID, int fireReachSpeedMS, int tileReach = 4);
	void Diffuse();

protected:
	

	float GetSecondsTillExplosion();
	void ProcessExplosion();
	void SetFireTo(CL_Vector2 vTilePos, eDir dir);
private:

	enum eState
	{
		STATE_DROPPING,
		STATE_TICKING,
		STATE_EXPLODING,
		STATE_DIFFUSED

	};

	int m_countDownTimer;
	int m_timeAtStart;
	int m_explosionReach;
	int m_curReach;
	int m_tileID;
	int m_fireReachSpeedMS;
	int m_nextProcessTime;
	eState m_state;
	bool m_reachDirActive[C_DIR_COUNT];
	int m_dropTimer;

};

#endif // EntBomb_h__