//  ***************************************************************
//  EntPlayer - Creation date: 12/15/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef EntPlayer_h__
#define EntPlayer_h__

#include "main.h"
#include "Entity.h"

enum
{
	C_KEY_UP  = 0x0001,
	C_KEY_DOWN = 0x0002,
	C_KEY_LEFT  =  0x0004,
	C_KEY_RIGHT =  0x0008,
	

};



class EntPlayer: public Entity
{
public:
	EntPlayer();
	virtual ~EntPlayer();
	void Update(float step);
	void ResetKeys();
	void OnKeyUp(const CL_InputEvent &key);
	void OnKeyDown(const CL_InputEvent &key);
	void UpdateMovement(float step);
	int GetCurTileID();
	void SetPosTile(int tileID);
	void KillInput();
	int GetLives();
	CL_Vector2 GetCurTilePos();

protected:


	enum eState
	{
		STATE_NORMAL,
		STATE_DEAD
	};
	void SetSpriteData(eDir dir);
	void SetSpriteData(CL_Sprite *pSprite);
	bool Init();
	virtual void Render();
	void Move(eDir dir);
	void ResetMove(eDir dir);
	bool CloseToTarget();
	void OnDie();
	void OnMessage(Message &msg);
	
	unsigned int m_Keys; //holds current state of player movement keys
	CL_Slot m_SlotKeyUp;
	CL_Slot m_SlotKeyDown;
	CL_Sprite *m_spriteDir[C_DIR_COUNT];
	CL_Sprite *m_spriteLastUsed;
	CL_Sprite *m_spriteDead;
	eState m_state;

	int m_activeTileID;
	int m_destTileID;
	int m_dirTimer[C_DIR_COUNT];
	eDir m_lastDir;
	int m_ignoreKeysUntilTimer;
	int m_invicibilityTimer;
	int m_lives;
	bool m_bInputKilled;
private:
};

#endif // EntPlayer_h__