#include "EntShow.h"
#include "GameLogic.h"

EntShow::EntShow()
{
	m_bKillOnFinish = false;
}

EntShow::~EntShow()
{
}

void EntShow::SetupText(const string &text, CL_Vector2 v, eText textType)
{
	m_msg = text;
	m_vPosition = v;
	m_textType = textType;
}

void EntShow::SetupPic(const string &file, CL_Vector2 v)
{
	SAFE_DELETE(m_sprite);

	CL_Surface s(file);

	CL_SpriteDescription d;
	d.add_frame(s.get_pixeldata());

	std::list<CL_SpriteDescription::FramePair> *pFramePairList =  (std::list<CL_SpriteDescription::FramePair>*)&d.get_frames();

	CL_Rect picSrcRect = CL_Rect(0,0,s.get_width(), s.get_height());
	pFramePairList->begin()->second = picSrcRect;
	m_sprite = new CL_Sprite(d);
	m_sprite->set_alignment(origin_top_left,0,0);
	m_vPosition = v;
}


void EntShow::OnMessage(Message &msg)
{
	
	Entity::OnMessage(msg);
}

void EntShow::Render()
{
	if (m_msg.empty())
	{
		Entity::Render();
	} else
	{
		//show the text
		int fontID = C_FONT_MAIN;
		switch (m_textType)
		{
		case TEXT_ENTITY:
			fontID = C_FONT_SMALL;
			break;
		}
		float fTemp = GetApp()->GetFont(fontID)->get_alpha();
		GetApp()->GetFont(fontID)->set_alpha(m_alpha);
		GetApp()->GetFont(fontID)->set_alignment(origin_center);
		GetApp()->GetFont(fontID)->draw(m_vPosition.x, m_vPosition.y, m_msg);
		GetApp()->GetFont(fontID)->set_alpha(fTemp);


	}
}