#ifndef _GAMELOGIC
#define _GAMELOGIC
#include "main.h"

using namespace std;

#include "main.h"
#include "MyEntityManager.h"
#include "MessageDispatcher.h"
#include "LevelLogic.h"

class EntPlayer;
class Message;

enum eText
{
	TEXT_NORMAL,
	TEXT_ENTITY
};



class Scoring
{
public:
	Scoring()
	{
		m_highscore = -999;
		m_passed = false;
	}
	bool m_passed;
	int m_highscore;
};

class GameLogic
{

public:

	enum eState
	{
		STATE_TITLE_SCREEN,
		STATE_PLAYING
	};

    GameLogic();
    virtual ~GameLogic();
      
      void Update(float step);
      void Render();
      void RebuildBuffers();
      MyEntityManager * GetMyEntityManager() {return &m_myEntityManager;}
      void Kill();
      void DrawGUI();
      void OnMessage(Message &msg);
      MessageDispatcher * GetMessageDispatcher(){return &m_messageDispatcher;}
      bool ShuttingDown() {return GetApp()->m_bQuit;}
      void ClearGame();
		
	  int m_spaceFunctionality;
	  void SetupTitleScreen();

	  void ShowText(string text, int timeMS, int x=500, int y=350);
	  void ModScore(int mod);
	  int GetScore() {return m_score;}
	  LevelLogic * GetLevelLogic() {return &m_levelLogic;}
	  void ModGirlsLeft(int mod) {m_girlsActive += mod;}
	  int GetGirlsLeft() {return m_girlsActive + m_levelLogic.GetGirlsToSpawn();}
	  Scoring * GetScoring(int level) {return &m_scoring[level];}
private:

	void RenderGUI();
	void ResetTimer();

    void OnKeyDown(const CL_InputEvent &key);
	void StartGame();
	void UpdateMainGame();
	void DrawMenuSelect();
	MyEntityManager m_myEntityManager;
    CL_Slot m_slotKeyDown;
    MessageDispatcher m_messageDispatcher;
	std::string m_textMessage;
	eState m_state;
	LevelLogic m_levelLogic;
	int m_score;
	bool m_bSpaceToInitLevel;
	string m_showText;
	int m_girlsActive;
	int m_levelSelected;
	Scoring m_scoring[C_LEVEL_COUNT+1];

 };

GameLogic * GetGameLogic();

MyEntityManager * GetEntityManager();
MessageDispatcher * GetMessageDispatcher();
LevelLogic * GetLevelLogic();
extern EntPlayer *g_pEntPlayer;
void QueueSound(string soundFile, int delayMS);
void Say(string text, Entity *pEnt, int delayMS);

#endif