#include "LevelLogic.h"
#include "EntBomb.h"
#include "GameLogic.h"
#include "Map.h"
#include "EntGirl.h"

LevelLogic::LevelLogic()
{
	m_bPaused = false;
	m_girlsToSpawn = 0;
	m_timeForNextSpawn = 0;

}

LevelLogic::~LevelLogic()
{
}

string LevelLogic::BuildSettingsString()
{
	string s = "Settings: ";

	if (m_bCanDisarmBombs) s+= "Wire Cutters ";
	if (m_bCanMakeWood) s+= "Wall Tools ";
	if (m_tileReach != 4) s+= "Fire Reach: "+CL_String::from_int(m_tileReach)+" ";
	if (m_fireReachSpeed != 20) s+= "Fire Spread Modded ";

	return s;
}

void LevelLogic::SetupLevelData()
{

	//defaults
	m_levelData = "";
	m_levelName = "Unnamed";
	
	m_levelText = "Rescue the girls!";
	m_bCanDisarmBombs = false;
	m_bCanMakeWood = false;
	m_bCanLayBombs = false;
	m_fireReachSpeed = 20;
	m_girlsToSpawn = 0;
	m_extra_lives = 3;
	m_timeBetweenGirlSpawns = 2000;
	m_girlSpawnTimer = 0;
	m_timeForNextSpawn = 0;
	m_tileReach = 4;

	if (m_curLevel == 1)
	{
		m_timebetweenBombSpawns = 1000;
		m_levelName = "Bomb Dodging";
		m_targetScore = 500;
		m_levelText = 
			"\r\nCan you dodge falling bombs?"\
			"\r\nControls:  Use the arrow keys to move\r\n"\
			"Settings: Default";
			"\r\nObjective: Rescue the women (touch them with your player)\r\n";
		
		m_levelData =
		"XXXXXXXXXXXXXXXX"\
		"X*X..XXX.....*.X"\
		"X.X..X*.X..X...X"\
		"X.X..X..X..X...X"\
		"X.X*.X..X.*X...X"\
		"X.X.....XXX....X"\
		"X*...........*.X"\
		"X*...........*.X"\
		"X*......S....*.X"\
		"XXXXXXXXXXXXXXXX";
	}

	if (m_curLevel == 2)
	{
		m_timebetweenBombSpawns = 700;
		m_levelName = "Making Walls";
		m_targetScore = 600;
		m_bCanMakeWood = true;
		m_levelText = 
			"New item:  Wall tools!\r\n"\
 			"\r\nPress SPACE to create or destroy a wood wall in front of you.\r\n"\
			"\r\nObjective: Rescue the women - DEAD OR ALIVE!\r\n"\
			"Settings: Wall Tools";
		m_levelData =
			"XXXXX*XSXXXXXXXX"\
			"XXXXX#X.XXXXXXXX"\
			"XXX.*..#..#XX*XX"\
			"XXX.XXX.XX.XX#XX"\
			"XXX.#..*XX.###XX"\
			"XXX.XXX..#..X.XX"\
			"XXX#XXX.XXX.X.XX"\
			"XX*..#...#.#.*XX"\
			"XXXXXXXXXXXXXXXX"\
			"XXXXXXXXXXXXXXXX";
	}


	if (m_curLevel == 3)
	{
		m_timebetweenBombSpawns = 700;
		m_levelName = "Defusing";
		m_targetScore = 800;
		m_bCanDisarmBombs = true;
		m_levelText = 
			"New item:  Wire Cutters!\r\n"\
			"\r\nTo diffuse a bomb is easy, just touch it.  Carefully.\r\n"\
			"\r\nObjective: Rescue people, get points by diffusing bombs\r\n"\
			"Settings: Wire Cutters";
		m_levelData =
			"S..............."\
			"................"\
			"XXXXXXX.XXXXXXXX"\
			"XX*XXXX.XXXXX*XX"\
			"XX*XXXX.XXXXX*XX"\
			"XX*XXXX.XXXXX*XX"\
			"XX*XXXX.XXXXX*XX"\
			"XX.XXXX.XXXXX.XX"\
			"XX.XXXX.XXXXX.XX"\
			"X.............XX";
	}

	if (m_curLevel == 4)
	{
		m_timebetweenBombSpawns = 1400;
		m_levelName = "Water and Slow Spread!";
		m_targetScore = 800;
		m_bCanDisarmBombs = true;
		m_bCanMakeWood = true;
		m_fireReachSpeed = 300;
		m_extra_lives = 1;
		m_levelText = 
			"Heroes don't like to get wet, so stay out of the water!\r\n"\
			"\r\nWatch out for these new 'Slow Spreading' bombs.\r\n"\
			"\r\nObjective: Save the girls, preferably alive\r\n"\
			"Settings: Wire Cutters, Wall Tools, Slow Spreading";
		m_levelData =
			"X.WW........WW*X"\
			"X.WW...S....WW.X"\
			"X*.....*......*X"\
			"X.WW.WW.WW..WW.X"\
			"X.WW.WW.WW..WW.X"\
			"X*.....*......*X"\
			"X.WW.WW.WW..WW.X"\
			"X.WW.WW.WW..WW.X"\
			"X*.....*......*X"\
			"XXXXXXXXXXXXXXXX";
	}


	if (m_curLevel == 5)
	{
		//m_girlsToSpawn = 0;

		m_timebetweenBombSpawns = 1000;
		m_levelName = "Rat In A Cage";
		m_targetScore = 400;
		m_bCanDisarmBombs =false;
		m_bCanMakeWood = false;
		m_extra_lives = 3;
		m_levelText = 
			"You've been locked up in a cage.\r\n"\
			"\r\nObjective: Escape and help the others\r\n"\
			"Settings: Quick Spread";
		m_levelData =
			"*#............#*"\
			"#..............#"\
			"................"\
			"........#......."\
			".......#S#......"\
			"........#......."\
			"................"\
			"................"\
			"#..............#"\
			"*#............#*";
	}

	if (m_curLevel == 6)
	{
		m_girlsToSpawn= 20;

		m_timebetweenBombSpawns = 1100;
		m_levelName = "Ring Of Death";
		m_targetScore = 2000;
		m_bCanDisarmBombs = true;
		m_bCanMakeWood = true;
		m_extra_lives = 3;
		m_levelText = 
			"Do you dare.. enter the RING?!\r\n"\
			"\r\nObjective: Frickin' live!\r\n"\
			"Settings: Wire Cutters, Wall Tools";
		m_levelData =
			"################"\
			"#######...######"\
			"######.WWW.#####"\
			"#####.W###W.####"\
			"####.W##.##W.###"\
			"####.W##.###.###"\
			"####..W####W.###"\
			"#####..WWWW.####"\
			"######.....#####"\
			"########S#######";
	}

	if (m_curLevel == 7)
	{
		m_girlsToSpawn= 20;

		m_timebetweenBombSpawns = 600;
		m_levelName = "The Grid";
		m_targetScore = 1000;
		m_bCanDisarmBombs = true;
		m_bCanMakeWood = true;
		m_extra_lives = 3;
		m_levelText = 
			"Things start to get crazy.\r\n"\
			"\r\nObjective: Frickin' live!\r\n"\
			"Settings: Wire Cutters, Wall Tools";
		m_levelData =
			"X.X.X.X.X.X.X.X."\
			"X..............."\
			"X.X.X.X.X.X.X.X."\
			"X..............."\
			"X.X.X.X.X.X.X.X."\
			"X......S........"\
			"X.X.X.X.X.X.X.X."\
			"X..............."\
			"X.X.X.X.X.X.X.X."\
			"X...............";

	}
	
	if (m_curLevel == 8)
	{
		m_girlsToSpawn= 5;

		m_timebetweenBombSpawns = 1500;
		m_levelName = "Duplicity";
		m_targetScore = 600;
		m_bCanDisarmBombs = true;
		m_bCanMakeWood = true;
		m_extra_lives = 1;
		m_levelText = 
			"What's better than a hero?  A team of heroes!\r\n"\
			"\r\nObjective: Frickin' live!\r\n"\
			"Settings: Wire Cutters, Wall Tools";
		m_levelData =
			"................"\
			"................"\
			"......S....S...."\
			"................"\
			"................"\
			"......S....S...."\
			"................"\
			"................"\
			"................"\
			"................";


	}


	if (m_curLevel == 9)
	{
		if (Random(2) == 0)
		{
			m_girlsToSpawn= Random(20);

		}

		m_timebetweenBombSpawns = 700 + Random(800);
		m_levelName = "Randomly Generated Level";
		
		m_bCanDisarmBombs = Random(2);
		m_bCanMakeWood = Random(2);
		m_timeBetweenGirlSpawns = 800 + Random(2300);
		m_extra_lives = Random(4)+1;
		
		if (Random(3) == 0)
		{
			m_fireReachSpeed = 10 + Random(300);
		}

		if (Random(3) == 0)
		{
			m_tileReach = 1 + Random(10);
		}
		m_levelText = 
		
			"Who knows what you're gonna get!\r\n"\
			"\r\nObjective: Frickin' live!\r\n";

		m_levelText += BuildSettingsString();

	

		char lev[C_TOTAL_TILES_IN_MAP+1];

		memset(lev, '.', C_TOTAL_TILES_IN_MAP+1); //start with it blank
		lev[C_TOTAL_TILES_IN_MAP] = 0; //add null at the end
		//add some rocks?

		if (Random(3) <= 1)
		{
			int count = Random(40);
			for (int i=0; i < count; i++)
			{
				lev[Random(C_TOTAL_TILES_IN_MAP)] = 'X';
			}
		}
	
		

		//water?
		if (Random(3) <= 1)
		{
			int count = Random(40);
			for (int i=0; i < count; i++)
			{
				lev[Random(C_TOTAL_TILES_IN_MAP)] = 'W';
			}
		}


		//Wood?
		if (Random(3) <= 1)
		{
			int count = Random(40);
			for (int i=0; i < count; i++)
			{
				lev[Random(C_TOTAL_TILES_IN_MAP)] = '#';
			}
		}
		int girls = 0;
		//girls?
		if (Random(2) == 1 || m_girlsToSpawn == 0)
		{
			int count = Random(15)+1;
			for (int i=0; i < count; i++)
			{
				girls++;
				lev[Random(C_TOTAL_TILES_IN_MAP)] = '*';
			}
		}
		//start pos
		lev[Random(C_TOTAL_TILES_IN_MAP)] = 'S';
		m_targetScore = (m_girlsToSpawn + girls) *65; 
		m_levelData = lev;
			
	} 

}


void LevelLogic::InitLevelData()
{

	int delayMS = 50;
	int tiles = m_levelData.size();

	for (int i=0; i < tiles; i++)
	{
		switch (m_levelData[i])
		{
			case 'X': AddTile(TILE_ROCK, i, delayMS); break;
			case 'S': AddTile(TILE_PLAYER_START, i, delayMS); break;
			case '*': AddTile(TILE_GIRL, i, delayMS); break;
			case 'W': AddTile(TILE_WATER, i, delayMS); break;
			case '#': AddTile(TILE_WOOD, i, delayMS); break;
		}

		if (i%C_MAP_SIZE_X == 0)
		{
			QueueSound("blip.wav", delayMS);
			delayMS += 150;
		}
	}

	m_timeForNextSpawn = GetApp()->GetGameTick() + delayMS;

	m_girlSpawnTimer = GetApp()->GetGameTick() + delayMS;

}

void LevelLogic::AddTile(eTileType tileType, int tileID, int delayMS)
{
	Message m;
	m.m_msg = C_MESSAGE_ADD_TILE;
	m.m_parm1 = tileID;
	m.m_parm = tileType;
	GetMessageDispatcher()->SendMsgEx(m, delayMS);
}

bool LevelLogic::Init(int level)
{
	m_bPaused = false;
	m_curLevel = level;
	SetupLevelData();
	return true; //success
}

void LevelLogic::SpawnBomb()
{
	int tileID = g_Map.GetEmptyTile(2);
	if (tileID == -1) return;
	
	EntBomb *pEnt = new EntBomb();
	GetEntityManager()->Add(pEnt);
	pEnt->Init(tileID, m_fireReachSpeed, m_tileReach);
}

void LevelLogic::SpawnGirl()
{
	int tileID = g_Map.GetEmptyTile();
	if (tileID == -1) return;

	m_girlsToSpawn--;
	EntGirl *pEnt = new EntGirl();
	GetEntityManager()->Add(pEnt);
	pEnt->Init(tileID);
}

string LevelLogic::GetLevelStartText()
{
	return "Mission: "+m_levelName+"\r\n\r\n"+m_levelText+"\r\n\r\nPress SPACE to continue.";
}

void LevelLogic::Update(float step)
{
	//spawn bombs
	if (m_timeForNextSpawn != 0 && m_timeForNextSpawn < GetApp()->GetGameTick())
	{
		SpawnBomb();
		m_timeForNextSpawn = GetApp()->GetGameTick() + (m_timebetweenBombSpawns/2) + (float(Random(m_timebetweenBombSpawns))*0.5);
	}

	if (m_girlsToSpawn > 0)
	{
		if (m_girlSpawnTimer != 0 && m_girlSpawnTimer < GetApp()->GetGameTick())
		{
			SpawnGirl();		
			m_girlSpawnTimer = GetApp()->GetGameTick() + (m_timeBetweenGirlSpawns/2) + (float(Random(m_timeBetweenGirlSpawns))*0.5);
		}
	}
}

void LevelLogic::SetPaused()
{
	m_bPaused = true;
	m_timeForNextSpawn = 0; //disable spawning
	m_girlSpawnTimer = 0;
}
string LevelLogic::GetRanking(float *fRating)
{
	float f = float(GetGameLogic()->GetScore())/ float(m_targetScore);
	*fRating = f;
	if (f >= 1.2) return "Dreamboat Hero"; else
	if (f >= 1.1) return "Kicking so much ass it hurts"; else
	if (f >= 1.0) return "Ready for the movies"; else
		if (f >= 0.9) return "That asian guy from Heroes"; else
			if (f >= 0.8) return "Ahnold"; else
				if (f >= 0.7) return "That dork from Never Ending Story"; else
					if (f >= 0.6) return "Willow Ufgood"; else
						if (f >= 0.5) return "Wicket from ROTJ"; else
							if (f >= 0.4) return "Couldn't rescue a paper bag"; else
								if (f >= 0.3) return "Pathetic"; else
									if (f >= 0.2) return "Try the fast food industry"; else
										if (f >= 0.1) return "Perhaps try playing victim?"; else
											if (f >= 0.0) return "Were you TRYING to lose?"; else
												if (f >= -0.2) return "Suck*#INF"; else
													if (f >= -0.4) return "Try a desk-job"; else
														if (f >= -0.6) return "Try steroids or something.  Anything."; else
										return "World is doomed";

	return "Error";

}
string LevelLogic::GetSummary()
{
	string t;

	float fRating;
	GetRanking(&fRating);

	bool bPassed = false;
	string verdict = "FAILED!";
	if (fRating > 0.5)
	{
		verdict = "PASSED!";	
		bPassed = true;
	}


	t = "Hero Mission Summary\r\n\r\n";
	//t += "Target Score: "+CL_String::from_int(GetGameLogic()->GetScore())+"\r\n\";
	t += "MISSION "+verdict+"\r\n";
	t += "Score: "+CL_String::from_int(GetGameLogic()->GetScore())+"\r\n";
	t += "Ranking: "+GetRanking(&fRating)+"\r\n";

	t += "\r\nPress SPACE to play this mission again,\r\nor ESC to quit back and choose another level.";

	//scoring stuff

	Scoring *pScoring = GetGameLogic()->GetScoring(m_curLevel);

	if (bPassed)
	{
		pScoring->m_passed = true;
	}

	if (GetGameLogic()->GetScore() > pScoring->m_highscore)
	{
		pScoring->m_highscore = GetGameLogic()->GetScore();
	
		for (int i=0; i < 50; i++)
		{
			GetGameLogic()->ShowText("NEW HIGH SCORE!", i*400+Random(100), Random(1000), 20+Random(700));
		}
	}


	return t;
		
}