//  ***************************************************************
//  LevelLogic - Creation date: 12/15/2007
//  -------------------------------------------------------------
//  Robinson Technologies Copyright (C) 2007 - All Rights Reserved
//
//  ***************************************************************
//  Programmer(s):  Seth A. Robinson (seth@rtsoft.com)
//  ***************************************************************

#ifndef LevelLogic_h__
#define LevelLogic_h__

#include "main.h"
#define C_LEVEL_COUNT 9


class LevelLogic
{
public:
	LevelLogic();
	virtual ~LevelLogic();

	bool Init(int level);
	void Update(float step);
	bool CanDisarmBombs() {return m_bCanDisarmBombs;}
	bool CanMakeWood() {return m_bCanMakeWood;}
	bool CanLayBombs() {return m_bCanLayBombs;}
	enum eTileType
	{
		TILE_ROCK,
		TILE_GIRL,
		TILE_PLAYER_START,
		TILE_WOOD,
		TILE_WATER

	};
	int GetGirlsToSpawn() {return m_girlsToSpawn;}

	void InitLevelData();
	string GetLevelStartText();
	string GetLevelName() {return m_levelName;}
	int GetLevelNum() {return m_curLevel;}
	bool IsPaused() {return m_bPaused;}
	void SetPaused();
	string GetSummary();
	int GetLives() {return m_extra_lives;}
	void SpawnBomb();

private:

	
	void SpawnGirl();
	void SetupLevelData();
	void AddTile(eTileType tileType, int tileID, int delayMS);
	string GetRanking(float *fRating);
	string BuildSettingsString();
	int m_timeForNextSpawn;
	int m_timebetweenBombSpawns;
	string m_levelData;
	int m_curLevel;
	string m_levelName;
	bool m_bCanDisarmBombs;
	string m_levelText;
	bool m_bCanMakeWood,m_bCanLayBombs;
	bool m_bPaused;
	int m_targetScore;
	int m_extra_lives;
	int m_fireReachSpeed;
	int m_girlsToSpawn;
	int m_girlSpawnTimer;
	int m_timeBetweenGirlSpawns ;
	int m_tileReach;
};

#endif // LevelLogic_h__
